unit Unit12;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ExtCtrls,  StdCtrls, ComCtrls,
  UnitV, Unit10 ;

type
  TForm12 = class(TForm)
    SG1: TStringGrid;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Edit1: TEdit;
    Button9: TButton;
    Button7: TButton;
    Button8: TButton;
    StatusBar1: TStatusBar;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ComboBox1Select(Sender: TObject);
    procedure ComboBox2Select(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
  private
    { Private 錾 }
    n,n1,n2 : integer ;
    wh1,od1 : string ;
    procedure SCellClear ;
    procedure SCellDisplay ;
  public
    { Public 錾 }
  end;

var
  Form12: TForm12;

implementation

uses
   Unit1 ;

{$R *.dfm}

// J
procedure TForm12.FormShow(Sender: TObject);
var
   i : integer ;
begin
   Width  := Fm12_w ;
   Height := Fm12_h ;
   for i:=0 to 12 do
      SG1.ColWidths[i] := Fm12_c[i] ;
   //
   n  := 100 ;    // 1y[W̃f[^
   n1 := 1 ;      // 擪R[hԍ
   n2 := 0 ;      // ł̃R[hԍ
   wh1:= '';      // WHERE߁ii荞ݗpj
   od1:= 'N';     // ORDER BYiяpj
   //
   with SG1 do begin
      Cells[ 0,0] := 'ԍ';
      Cells[ 1,0] := '}ʖ';
      Cells[ 2,0] := '}';
      Cells[ 3,0] := '\';
      Cells[ 4,0] := '';
      Cells[ 5,0] := 'P';
      Cells[ 6,0] := 'p';
      Cells[ 7,0] := '쐬t';
      Cells[ 8,0] := 'XVt';
      Cells[ 9,0] := '}t';
      Cells[10,0] := 'Ft';
      Cells[11,0] := 'o}t';
      Cells[12,0] := 't';
      RowCount := n + 1;
   end;
   SCellClear ;
   Button4Click(Sender);   // [XV]
   Button1.SetFocus ;
end;

// 
procedure TForm12.FormClose(Sender: TObject; var Action: TCloseAction);
var
   i : integer ;
begin
   Fm12_w := Width ;
   Fm12_h := Height ;
   for i:=0 to 12 do
      Fm12_c[i] := SG1.ColWidths[i] ;

   Action := caFree ;
end;

// eNA
procedure TForm12.SCellClear ;
var
   i,j : integer ;
begin
   with SG1 do begin
      for j:=1 to RowCount-1 do
         for i:=0 to ColCount-1 do
            Cells[i,j] := '';
   end;
end;

// f[^ǂݍ
procedure TForm12.SCellDisplay ;
var
   j : integer ;
   px,py : double ;
begin
   with Form1 do begin
      IBQuery1.Active := False ;
      IBTransaction1.Active := False ;
      IBQuery1.ParamCheck := True ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('SELECT * FROM '+TABLE5);
         if (wh1 <> '') then begin
            Add('  WHERE ' + wh1);
         end;
         Add('  ORDER BY ' + od1 + ';');
      end;
      j := 1 ;
      //
      try
         IBQuery1.Open ;
         IBQuery1.First ;
         if (n1 > 1) then IBQuery1.MoveBy(n1-1);
         while not(IBQuery1.Eof) do begin
            SG1.Cells[ 0,j] := IBQuery1.FieldByName('N').AsString ;
            SG1.Cells[ 1,j] := IBQuery1.FieldByName('ZNAME').AsString ;
            SG1.Cells[ 2,j] := IBQuery1.FieldByName('ZUMENN').AsString ;
            SG1.Cells[ 3,j] := IBQuery1.FieldByName('MTITLE').AsString ;
            SG1.Cells[ 4,j] := IBQuery1.FieldByName('STITLE').AsString ;
            SG1.Cells[ 5,j] := IBQuery1.FieldByName('MEMO1').AsString ;
            SG1.Cells[ 6,j] := PaperSize(IBQuery1.FieldByName('PAPER').AsInteger,px,py); ;
            SG1.Cells[ 7,j] := IBQuery1.FieldByName('DDATE').AsString ;
            SG1.Cells[ 8,j] := IBQuery1.FieldByName('UDATE').AsString ;
            SG1.Cells[ 9,j] := IBQuery1.FieldByName('KDATE').AsString ;
            SG1.Cells[10,j] := IBQuery1.FieldByName('ADATE').AsString ;
            SG1.Cells[11,j] := IBQuery1.FieldByName('PDATE').AsString ;
            SG1.Cells[12,j] := IBQuery1.FieldByName('RDATE').AsString ;

            Inc(j);
            if (j > n) then break ;
            IBQuery1.Next ;
         end;
      except
         ;
      end;
      IBQuery1.Active := False ;
      n2 := n1 + j - 1;
   end;
end;

// ŏ
procedure TForm12.Button1Click(Sender: TObject);
begin
   SCellClear ;
   n1 := 1 ;
   SCellDisplay ;
end;

// O
procedure TForm12.Button2Click(Sender: TObject);
begin
   SCellClear ;
   if (n1 > 1) then begin
      n1 := n1 - n ;
      if (n1 < 1) then n1 := 1 ;
   end;
   SCellDisplay ;
end;

// 
procedure TForm12.Button3Click(Sender: TObject);
begin
   SCellClear ;
   n1 := n2 ;
   SCellDisplay ;
end;

// XV
procedure TForm12.Button4Click(Sender: TObject);
begin
   SCellClear ;
   SCellDisplay ;
end;

// яύX
procedure TForm12.ComboBox1Select(Sender: TObject);
var
   i : integer ;
begin
   i := ComboBox1.ItemIndex ;
   if (i = -1) then exit ;
   Case(i)of
    0:begin // ԍ
         od1 := 'N' ;
      end;
    1:begin // ԍ
         od1 := 'N DESC' ;
      end;
    2:begin // }ʖ́
         od1 := 'ZNAME,N' ;
      end;
    3:begin // }ʖ́
         od1 := 'ZNAME DESC,N DESC' ;
      end;
    4:begin // }ԁ
         od1 := 'ZUMENN,N' ;
      end;
    5:begin // }ԁ
         od1 := 'ZUMENN DESC,N DESC' ;
      end;
    6:begin // \聫
         od1 := 'MTITLE,N' ;
      end;
    7:begin // \聪
         od1 := 'MTITLE DESC,N DESC' ;
      end;
    8:begin // P
         od1 := 'MEMO1,N' ;
      end;
    9:begin // P
         od1 := 'MEMO1 DESC,N DESC' ;
      end;
   10:begin // 쐬t
         od1 := 'DDATE,N' ;
      end;
   11:begin // 쐬t
         od1 := 'DDATE DESC,N DESC' ;
      end;
   12:begin // XVt
         od1 := 'UDATE,N' ;
      end;
   13:begin // XVt
         od1 := 'UDATE DESC,N DESC' ;
      end;
   14:begin // }t
         od1 := 'KDATE,N' ;
      end;
   15:begin // }t
         od1 := 'KDATE DESC,N DESC' ;
      end;
   16:begin // Ft
         od1 := 'ADATE,N' ;
      end;
   17:begin // Ft
         od1 := 'ADATE DESC,N DESC' ;
      end;
   18:begin // o}t
         od1 := 'PDATE,N' ;
      end;
   19:begin // o}t
         od1 := 'PDATE DESC,N DESC' ;
      end;
   20:begin // t
         od1 := 'RDATE,N' ;
      end;
   21:begin // t
         od1 := 'RDATE DESC,N DESC' ;
      end;
   end;

   Button1Click(Sender);   // ŏ
end;

// i荞
procedure TForm12.ComboBox2Select(Sender: TObject);
var
   i : integer ;
   s : string ;
begin
   i := ComboBox2.ItemIndex ;
   if (i = -1) then exit ;
   s := Edit1.Text ;
   if (s = '') then i := 0 ;
   Case(i)of
    0:begin // ij
         wh1 := '';
      end;
    1:begin // }ʖ
         wh1 := 'ZNAME' ;
      end;
    2:begin // }
         wh1 := 'ZUMENN' ;
      end;
    3:begin // \
         wh1 := 'MTITLE' ;
      end;
    4:begin // 
         wh1 := 'STITLE' ;
      end;
    5:begin // P
         wh1 := 'MEMO1' ;
      end;
    6:begin // 쐬t
         wh1 := 'DDATE' ;
      end;
    7:begin // XVt
         wh1 := 'UDATE' ;
      end;
    8:begin // }t
         wh1 := 'KDATE' ;
      end;
    9:begin // Ft
         wh1 := 'ADATE' ;
      end;
   10:begin // o}t
         wh1 := 'PDATE' ;
      end;
   11:begin // t
         wh1 := 'RDATE' ;
      end;
   end;

   if (wh1 <> '') then begin
      wh1 := wh1 + ' LIKE ''%' + s + '%''' ;
   end;
   Button1Click(Sender);   // ŏ
end;

// ҏW
procedure TForm12.Button7Click(Sender: TObject);
var
   n : integer ;
   fm : TForm10 ;
begin
   n := SInt(SG1.Cells[0,SG1.Row]) ;
   if (n <= 0) then exit ;

   S_TYPE := 1 ;
   S_CODE1:= n ;
   try
      fm := TForm10.Create(Application) ;
      fm.Caption := 'CAD}ʈꗗ ҏW';
      fm.Show ;
   except
      ;
   end;
end;

// CAD\tgN
procedure TForm12.Button8Click(Sender: TObject);
var
   n : integer ;
//   fm : TForm13 ;
begin
   n := SInt(SG1.Cells[0,SG1.Row]) ;
   if (n <= 0) then exit ;

   S_CODE1 := n ;
{
   try
      fm := TForm13.Create(Application) ;
      fm.Caption := 'CAD | ' + SG1.Cells[1,SG1.Row] + '(N:' + IntToStr(n) + ')' ;
      fm.Show ;
   except
      ;
   end;
}
end;

// [f[^폜]
//    CAD}ʈꗗf[^Af[^ACADf[^܂
procedure TForm12.Button9Click(Sender: TObject);
var
   i,n : integer ;
   s : string ;
   // t : string ;
begin
   i := SG1.Row ;
   n := SInt(SG1.Cells[0,i]) ;
   if (n <= 0) then exit ;

   s := 'CAD}ʃf[^u' + SG1.Cells[1,i] + 'v(N:' + IntToStr(n) + ')' ;
{
   t := TABLE7 + IntToStr(n) ;
   if not(Form1.DataTableCheck(t)) then begin
      ShowMessage(s + '̃e[uf[^݂͑܂B');
      exit ;
   end;
}
   if MessageDlg(s + '폜܂iꗗf[^폜܂jB낵łH',
      mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit ;

   // CAD}ʈꗗf[^̍s폜
   s := 'N=' + IntToStr(n);
   Form1.TableDel(TABLE5,s);
   // f[^̍s폜
   s := 'ZN=' + IntToStr(n);
   Form1.TableDel(TABLE6,s);
   // CADf[^̍폜
   // Form1.DataTableDelete(t);

   // XV
   Button4Click(Sender);
end;

end.
