unit Unit7;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ExtCtrls,
  UnitV ;

type
  TForm7 = class(TForm)
    SG1: TStringGrid;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Panel1: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    ComboBox1: TComboBox;
    Label5: TLabel;
    Edit3: TEdit;
    Label6: TLabel;
    Edit4: TEdit;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SG1Click(Sender: TObject);
    procedure Edit1DblClick(Sender: TObject);
    procedure Edit3DblClick(Sender: TObject);
    procedure Edit4DblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
    procedure TableDisplay ;
  public
    { Public 錾 }
  end;

var
  Form7: TForm7;

implementation

uses
   Unit1 ;

{$R *.dfm}

// N
procedure TForm7.FormShow(Sender: TObject);
var
   i,n : integer ;
   s : array of string ;
begin
   Edit1.Text := '' ;
   Edit2.Text := '' ;
   Edit3.Text := '' ;
   Edit4.Text := '' ;
   
   with SG1 do begin
      RowCount := 2 ;
      Cells[0,0] := 'ԍ';
      Cells[1,0] := '쐬';
      Cells[2,0] := '';
      Cells[3,0] := 't';
      Cells[4,0] := '';
      for i:=0 to ColCount-1 do
         Cells[i,1] := '' ;
   end;
   if (Trim(DBfold) = '')or(Trim(DBname) = '') then begin
      ShowMessage('ŏɃf[^x[X̐ݒsĉB');
      close ;
      exit ;
   end;
   // ڑ`FbNiꉞj
   if not(Form1.IBDatabase1.Connected) then begin
      ShowMessage('f[^x[Xɐڑo܂BݒmFĉB');
      close ;
      exit ;
   end;
   // e[u Form1 ĂяoOɍ쐬ς

   // o(MEMBER)e[uComboBox1
   ComboBox1.Items.Clear ;
   ComboBox1.Items.Add('0:w薳');
   if (Form1.DataTableCheck(TABLE2)) then begin
      n := Form1.TableRef('*',TABLE2,'','N');
      SetLength(s,TABLE2N);
      for i:=1 to n do begin
         if (i = 1) then
            Form1.TableFirst(s)
         else
            Form1.TableNext(s);
         ComboBox1.Items.Add(s[0]+':'+s[2]);
      end;
      Form1.TableClose ;
      s := nil;
   end;
   ComboBox1.ItemIndex := 0 ;
   
   // e[uQƁEꗗ\
   TableDisplay ;

   SG1.Row := 1 ;
   SG1Click(Sender) ;
   SG1.SetFocus ;
end;

// I
procedure TForm7.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   //
end;

// e[uQƁEꗗ\
procedure TForm7.TableDisplay ;
var
   i,j,n : integer ;
   s : array of string ;
begin
   SG1.RowCount := 2 ;
   for i:=0 to SG1.ColCount-1 do
      SG1.Cells[i,1] := '' ;

   n := Form1.TableRef('*',TABLE3,'','N');
   if (n > 0) then begin
      SG1.RowCount := n+1 ;
      SetLength(s,TABLE3N);
      for i:=1 to n do begin
         if (i = 1) then
            Form1.TableFirst(s)
         else
            Form1.TableNext(s);
         for j:=0 to TABLE3N-1 do
            SG1.Cells[j,i] := s[j] ;
      end;
      Form1.TableClose ;
      s := nil;
   end;
end;

// \NbN
procedure TForm7.SG1Click(Sender: TObject);
var
   i,j,k : integer ;
   s : string ;
begin
   i := SG1.Row ;
   s := SG1.Cells[0,i] ;
   if (s = '') then exit ;
   Edit1.Text := s ;
   Edit2.Text := SG1.Cells[2,i] ;
   Edit3.Text := SG1.Cells[3,i] ;
   Edit4.Text := SG1.Cells[4,i] ;
   j := SInt(SG1.Cells[1,i]);
   with ComboBox1 do begin
      ItemIndex := 0 ;
      for i:=1 to Items.Count-1 do begin
         k := SInt(GetStrCode(Items[i])) ;
         if (j = k) then begin
            ItemIndex := i ;
            break ;
         end;
      end;
   end;
end;

// ԍŃ_uNbNŏIԍ+1
procedure TForm7.Edit1DblClick(Sender: TObject);
var
   n : integer ;
begin
   n := SInt(Form1.GetMaxValue(TABLE3,'N',''));
   Edit1.Text := IntToStr(n+1);
end;

// tŃ_uNbN{̓t
procedure TForm7.Edit3DblClick(Sender: TObject);
begin
   ShortDateFormat := 'yyyymmdd' ;
   Edit3.Text := DateToStr(Now);
end;

// ԂŃ_uNbN̎
procedure TForm7.Edit4DblClick(Sender: TObject);
begin
   LongTimeFormat  := 'hhnnss' ;
   Edit4.Text := TimeToStr(Now) ;
end;

// o^
procedure TForm7.Button1Click(Sender: TObject);
var
   n,sn,i : integer ;
   fs: array of string ;
   s : array of string ;
begin
   // ----- ԍ̃`FbN -----
   if (Trim(Edit1.Text) = '') then begin
      ShowMessage('ԍ͂ĉi̐ĺj');
      Edit1.SetFocus ;
      exit ;
   end;
   n := SInt(Edit1.Text) ;
   if (n <= 0) then begin
      ShowMessage('ԍ͐̐œ͂ĉ');
      Edit1.SetFocus ;
      exit ;
   end;
   // ----- t̃`FbN -----
   if (Edit3.Text <> '') then begin
      if not(CheckDate(Edit3.Text)) then begin
         ShowMessage('t yyyymmdd`iF20100101jŗLȓe͂ĉB');
         Edit3.SetFocus ;
         exit ;
      end;
   end;
   // ----- Ԃ̃`FbN -----
   if (Edit4.Text <> '') then begin
      if not(CheckNum(Edit4.Text)) then begin
         ShowMessage('Ԃ hhmmss`i13:02:00130200jŗLȓe͂ĉB');
         Edit4.SetFocus ;
         exit ;
      end;
   end;

   i := ComboBox1.ItemIndex ;
   sn:= SInt(GetStrCode(ComboBox1.Items[i]));

   SetLength(fs,TABLE3N);
   SetLength(s ,TABLE3N);

   fs[0] := 'N';
   fs[1] := 'MN';
   fs[2] := 'CTEXT';
   fs[3] := 'CDATE';
   fs[4] := 'CTIME';

   s[0] := IntToStr(n) ;
   s[1] := IntToStr(sn) ;
   s[2] := Edit2.Text ;
   s[3] := Edit3.Text ;
   s[4] := Edit4.Text ;

   for i:=2 to 4 do begin
      if (AnsiPos('''',s[i]) > 0) or (AnsiPos('"',s[i]) > 0) then begin
         fs := nil ;
         s  := nil ;
         ShowMessage('pu''vu"v͂Ȃŉ');
         Edit2.SetFocus;
         exit;
      end;
   end;
   for i:=2 to 4 do begin
      if (s[i] = '') then
         s[i] := 'NULL'
      else
         s[i] := '''' + s[i] + '''' ;
   end;

   if (Form1.TableAdd(TABLE3,TABLE3N,fs,s)) then begin
      ShowMessage('o^OK');
   end
   else begin
      ShowMessage('o^s');
   end;

   fs := nil ;
   s  := nil ;

   TableDisplay ;
end;

// 폜
procedure TForm7.Button2Click(Sender: TObject);
var
   i,i1,i2,j : integer ;
   s : string ;
begin
   if (SG1.RowCount = 2)and(SInt(SG1.Cells[0,1]) = 0) then exit ;

   i1 := SG1.Selection.Top ;
   i2 := SG1.Selection.Bottom ;
   if (i1 = i2) then begin
      s := 'No.' + SG1.Cells[0,i1] + 'F' + SG1.Cells[2,i1] ;
      if MessageDlg('u'+s+'v폜܂B' + #13 + #10 + '낵łH',
         mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit ;
   end
   else begin
      s := 'No.' + SG1.Cells[0,i1] + '`' + SG1.Cells[0,i2] ;
      if MessageDlg(s+' 폜܂B' + #13 + #10 + '낵łH',
      mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit ;
   end;

   for i:=i1 to i2 do begin
      j := SInt(SG1.Cells[0,i]) ;
      if (j <= 0) then continue ;
      Form1.TableDel(TABLE3,'N='+IntToStr(j));
   end;
   //
   TableDisplay ;
end;

// 
procedure TForm7.Button3Click(Sender: TObject);
begin
   close;
end;

// ύX
procedure TForm7.Button4Click(Sender: TObject);
var
   n,sn,i : integer ;
   fs: array of string ;
   s : array of string ;
   w : string ;
begin
   // ----- ԍ̃`FbN -----
   if (Trim(Edit1.Text) = '') then begin
      ShowMessage('ԍ͂ĉi̐ĺj');
      Edit1.SetFocus ;
      exit ;
   end;
   n := SInt(Edit1.Text) ;
   if (n <= 0) then begin
      ShowMessage('ԍ͐̐œ͂ĉ');
      Edit1.SetFocus ;
      exit ;
   end;
   // ----- t̃`FbN -----
   if (Edit3.Text <> '') then begin
      if not(CheckDate(Edit3.Text)) then begin
         ShowMessage('t yyyymmdd`iF20100101jŗLȓe͂ĉB');
         Edit3.SetFocus ;
         exit ;
      end;
   end;
   // ----- Ԃ̃`FbN -----
   if (Edit4.Text <> '') then begin
      if not(CheckNum(Edit4.Text)) then begin
         ShowMessage('Ԃ hhmmss`i13:02:00130200jŗLȓe͂ĉB');
         Edit4.SetFocus ;
         exit ;
      end;
   end;

   i := ComboBox1.ItemIndex ;
   sn:= SInt(GetStrCode(ComboBox1.Items[i]));
   //
   // f[^`FbN
   if not(Form1.CheckValue(TABLE3,'N','', n)) then begin
      ShowMessage('͂ԍ͖gpł̂ŕύX͏o܂Bē͂ĉ');
      Edit1.SetFocus ;
      exit ;
   end ;
   //
   SetLength(fs,TABLE3N);
   SetLength(s ,TABLE3N);

   fs[0] := 'N';
   fs[1] := 'MN';
   fs[2] := 'CTEXT';
   fs[3] := 'CDATE';
   fs[4] := 'CTIME';

   s[0] := IntToStr(n) ;
   s[1] := IntToStr(sn) ;
   s[2] := Edit2.Text ;
   s[3] := Edit3.Text ;
   s[4] := Edit4.Text ;

   for i:=2 to 4 do begin
      if (AnsiPos('''',s[i]) > 0) or (AnsiPos('"',s[i]) > 0) then begin
         fs := nil ;
         s  := nil ;
         ShowMessage('pu''vu"v͂Ȃŉ');
         Edit2.SetFocus;
         exit;
      end;
   end;
   for i:=2 to 4 do begin
      if (s[i] = '') then
         s[i] := 'NULL'
      else
         s[i] := '''' + s[i] + '''' ;
   end;

   w := 'N=' + IntToStr(n) ;

   if (Form1.TableEdit(TABLE3,TABLE3N,fs,s,w)) then begin
      ShowMessage('ύXOK');
   end
   else begin
      ShowMessage('ύXs');
   end;

   fs := nil ;
   s  := nil ;

   TableDisplay ;
end;

end.
